# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeploymentIdVersionsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'main_model_experiment_version_id': 'str',
        'main_model_id': 'str',
        'challenger_model_experiment_version_id': 'str',
        'challenger_model_id': 'str'
    }

    attribute_map = {
        'main_model_experiment_version_id': 'main_model_experiment_version_id',
        'main_model_id': 'main_model_id',
        'challenger_model_experiment_version_id': 'challenger_model_experiment_version_id',
        'challenger_model_id': 'challenger_model_id'
    }

    def __init__(self, main_model_experiment_version_id=None, main_model_id=None, challenger_model_experiment_version_id=None, challenger_model_id=None):  # noqa: E501
        """DeploymentIdVersionsBody - a model defined in Swagger"""  # noqa: E501
        self._main_model_experiment_version_id = None
        self._main_model_id = None
        self._challenger_model_experiment_version_id = None
        self._challenger_model_id = None
        self.discriminator = None
        self.main_model_experiment_version_id = main_model_experiment_version_id
        self.main_model_id = main_model_id
        if challenger_model_experiment_version_id is not None:
            self.challenger_model_experiment_version_id = challenger_model_experiment_version_id
        if challenger_model_id is not None:
            self.challenger_model_id = challenger_model_id

    @property
    def main_model_experiment_version_id(self):
        """Gets the main_model_experiment_version_id of this DeploymentIdVersionsBody.  # noqa: E501


        :return: The main_model_experiment_version_id of this DeploymentIdVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._main_model_experiment_version_id

    @main_model_experiment_version_id.setter
    def main_model_experiment_version_id(self, main_model_experiment_version_id):
        """Sets the main_model_experiment_version_id of this DeploymentIdVersionsBody.


        :param main_model_experiment_version_id: The main_model_experiment_version_id of this DeploymentIdVersionsBody.  # noqa: E501
        :type: str
        """
        if main_model_experiment_version_id is None:
            raise ValueError("Invalid value for `main_model_experiment_version_id`, must not be `None`")  # noqa: E501

        self._main_model_experiment_version_id = main_model_experiment_version_id

    @property
    def main_model_id(self):
        """Gets the main_model_id of this DeploymentIdVersionsBody.  # noqa: E501


        :return: The main_model_id of this DeploymentIdVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._main_model_id

    @main_model_id.setter
    def main_model_id(self, main_model_id):
        """Sets the main_model_id of this DeploymentIdVersionsBody.


        :param main_model_id: The main_model_id of this DeploymentIdVersionsBody.  # noqa: E501
        :type: str
        """
        if main_model_id is None:
            raise ValueError("Invalid value for `main_model_id`, must not be `None`")  # noqa: E501

        self._main_model_id = main_model_id

    @property
    def challenger_model_experiment_version_id(self):
        """Gets the challenger_model_experiment_version_id of this DeploymentIdVersionsBody.  # noqa: E501


        :return: The challenger_model_experiment_version_id of this DeploymentIdVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._challenger_model_experiment_version_id

    @challenger_model_experiment_version_id.setter
    def challenger_model_experiment_version_id(self, challenger_model_experiment_version_id):
        """Sets the challenger_model_experiment_version_id of this DeploymentIdVersionsBody.


        :param challenger_model_experiment_version_id: The challenger_model_experiment_version_id of this DeploymentIdVersionsBody.  # noqa: E501
        :type: str
        """

        self._challenger_model_experiment_version_id = challenger_model_experiment_version_id

    @property
    def challenger_model_id(self):
        """Gets the challenger_model_id of this DeploymentIdVersionsBody.  # noqa: E501


        :return: The challenger_model_id of this DeploymentIdVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._challenger_model_id

    @challenger_model_id.setter
    def challenger_model_id(self, challenger_model_id):
        """Sets the challenger_model_id of this DeploymentIdVersionsBody.


        :param challenger_model_id: The challenger_model_id of this DeploymentIdVersionsBody.  # noqa: E501
        :type: str
        """

        self._challenger_model_id = challenger_model_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeploymentIdVersionsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeploymentIdVersionsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
